import processing.core.PApplet;
import processing.core.PConstants;

public class BeakPLimb extends PatchableLimb {

	BeakPLimb(PApplet p, Constitution constitution) {
		super(p, constitution);
		DefaultValues.loadBeak(this);
	}

	protected void drawStillRender() {
		float lParam = scaling.getL();
		render.triangle(-lParam, 0, 0, 0, 0, 1);
		render.triangle(+lParam, 0, 0, 0, 0, 1);
		type = 0;
	}

	protected void drawOpenRender(float time) {
		float angle = PConstants.PI / 2
				+ (PApplet.sin(time * PConstants.TWO_PI) + 1.1f) / 3;
		float lParam = scaling.getL();
		float xTop = PApplet.cos(angle) * 1;
		float yTop = PApplet.sin(angle) * 1;
		render.triangle(-lParam, 0, 0, 0, xTop, yTop);
		render.triangle(+lParam, 0, 0, 0, -xTop, yTop);
	}

	@Override
	protected void drawFFlyingRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawJAirRender(float time) {
		drawOpenRender(time);
	}

	@Override
	protected void drawJCrounchRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawJgroundRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWIdlingRender(float time) {
		drawOpenRender(time);
	}

	@Override
	protected void drawWJumpingRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWWalkingRender(float time) {
		drawStillRender();
	}

}
