import processing.core.PApplet;
import processing.core.PConstants;

public class BlockPLimb extends PatchableLimb {

	public BlockPLimb(PApplet p, Constitution constitution) {
		super(p, constitution);
		type = 1;		
	}

	protected void drawStillRender() {
		float lParam = scaling.getL();
		if (shapeType == 0) {
			render.rect(-lParam, -1, lParam * 2, 2);
		} else if (shapeType == 1) {
			render.triangle(-lParam, 0, +lParam, 0, 0, 1);
		} else if (shapeType == 2) {
			render.ellipse(0, 0, lParam, lParam);
		}
	}

	protected void drawTwistedRender(float time) {
		float sinusoid = (PApplet.sin(time * PConstants.TWO_PI) + 1) / 2;
		float lParam = scaling.getL() * (sinusoid + 1) / 2;
		if (shapeType == 0) {
			render.rect(-lParam, -1, lParam * 2, 2);
		} else if (shapeType == 1) {
			render.triangle(-lParam, 0, +lParam, 0, 0, 1);
		} else if (shapeType == 2) {
			render.ellipse(0, 0, lParam, lParam);
		}
	}

	@Override
	protected void drawFFlyingRender(float time) {
		drawTwistedRender(time);
	}

	@Override
	protected void drawJAirRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawJCrounchRender(float time) {
		drawTwistedRender(time);
	}

	@Override
	protected void drawJgroundRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWIdlingRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWJumpingRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWWalkingRender(float time) {
		drawTwistedRender(time);
	}

}
