import processing.core.PConstants;

public class DefaultValues {

	public DefaultValues() {
	}

	public static Animation animation() {
		int[] nbFrames = { 1, 24, 36, 17, 13, 13, 12, 11 };
		// 0 : Still 1
		// 1 : Walker walking 24
		// 2 : Walker idling 36
		// 3 : Walker jumping 17
		// 4 : Fly flying 13
		// 5 : Jumper crouch 13
		// 6 : Jumper air 12
		// 7 : Jumper ground 11
		return new Animation(nbFrames);
	}

	public static void loadULimb(UniqueLimb uLimb) {
		uLimb.setNumber(3);
		uLimb.setVariance((float) 0.5);
	}

	public static void loadLimb(Limbs limbs) {
		limbs.scaling.setSize((float) 1 / (float) 4, (float) 1 / (float) 4);
		limbs.scaling.setTran(0, 0);
		limbs.shapeType = 0;
	}

	public static void loadColor(ColorParam colorParam) {
		colorParam.setARGB((byte) 0xFF, (byte) 0x55, (byte) 0x66, (byte) 0x77);
	}

	public static void loadMainBody(MainBody mainBody) {
		mainBody.setWidth(100);
		mainBody.setHeight(100);
	}

	public static void loadOutlineParam(OutlineParam outlineParam) {
		outlineParam.setStrokeWidth((float) 2);
		outlineParam.setStrokeContrast((float) 0.6);
		outlineParam.setShadowLevel((float) 0.7);
		outlineParam.setShadowContrast((float) 0.8);
		outlineParam.setShadowPosition((float) PConstants.PI * 1 / 2);
		outlineParam.setShadowDistance((float) 0.6);
	}

	public static void size(Rendering rendering) {
		rendering.size(500, 500);
	}

	public static void loadSpikes(SpikesULimb spikesULimb) {
		spikesULimb.density = 7;
		spikesULimb.complete = false;
	}

	public static void loadFeet(FeetULimb feet) {
		feet.setConvergeance(0.5f);
		feet.setBase(0f);
	}

	public static void loadWings(WingsULimb wings) {
		wings.setLargeur(0.3f);
		wings.setBase(0.3f);
		wings.getScaling().setL(0.7f);
	}

	public static void loadEye(EyePLimb eye) {
		eye.getScaling().setW(0.15f);
		eye.getScaling().setH(0.15f);
	}

	public static void loadBeak(BeakPLimb beak) {
		beak.getScaling().setR((float) Math.PI);
	}

	public static void loadTummy(TummyULimb tummy) {
		tummy.setDivs(32);// number of vertex
		tummy.setIrreg(0.1f);// default values
		tummy.setShapeType(1);
		tummy.getMovement().setAmount(1);
	}
}
