import java.util.Vector;

import processing.core.PApplet;
import processing.core.PConstants;

public class Movement {

	public int getType() {
		return type;
	}

	public void setType(int type) {
		this.type = type;
	}

	public float getAmount() {
		return amount;
	}

	public void setAmount(float amount) {
		this.amount = amount;
	}

	int type;// still, follow, orbit, pendulum
	float amount;

	Movement() {
		type = 0;
		amount = 0.25f;
	}

	public void randomSet() {
		type = (int) (Math.random() * 4);
		amount = (float) (Math.random());
	}

	public float[] getTranslationFor(int anim, float time) {
		float trans[] = new float[2];
		if (type == 0) {
			if (anim == 1) {
				trans[0] = -PApplet.sin(time * PConstants.TWO_PI) * amount / 4;
				trans[1] = PApplet.sin(time * PConstants.TWO_PI) * amount / 4
						* (1 - PApplet.abs(time - 0.5f) * 2);
			}
			if (anim == 3) {
				trans[0] = 0;
				trans[1] = PApplet.sin(time * PConstants.TWO_PI) * amount / 3
						* (1 - PApplet.abs(time - 0.5f) * 2);
			}
			if (anim == 5) {
				trans[0] = 0;
				trans[1] = (-PApplet.sin(time * PConstants.TWO_PI) * amount / 5 + 1 / 3)
						* (1 - PApplet.abs(time - 0.5f) * 2);
			}
			if (anim == 6) {
				trans[0] = 0;
				trans[1] = (PApplet.sin(time * PConstants.TWO_PI) * amount / 3 + 1 / 3)
						* (1 - PApplet.abs(time - 0.5f) * 2);
			}
		}
		return trans;
	}

	public String[] getSaveStrings() {
		String[] result = new String[2];
		result[0] = PApplet.str(type);
		result[1] = PApplet.str(amount);
		return result;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		type = Integer.parseInt(toLoad.remove(0));
		amount = Float.parseFloat(toLoad.remove(0));
		return toLoad;
	}

}
