import java.util.Vector;

import processing.core.PApplet;
import processing.core.PConstants;

public class OutlineParam {

	float strokeWidth;
	float strokeContrast;// 0 = light - 1 = dark
	float shadowLevel;// 0 = no shadow - 1 = entire shadow
	float shadowContrast;// 0 = same as core - 1 = darker
	float shadowPosition;// from 0 to TWO_PI
	float shadowDistance;// 0 center - 1 border
	boolean strokeVisible;

	public boolean isStrokeVisible() {
		return strokeVisible;
	}

	public void setStrokeVisible(boolean strokeVisible) {
		this.strokeVisible = strokeVisible;
	}

	public void switchStrokeVisible() {
		strokeVisible ^= true;
	}

	public float getShadowPosition() {
		return shadowPosition;
	}

	public float getShadowDistance() {
		return shadowDistance;
	}

	public void setShadowDistance(float shadowDistance) {
		this.shadowDistance = shadowDistance;
	}

	public void setShadowPosition(float shadowPosition) {
		this.shadowPosition = shadowPosition;
	}

	OutlineParam() {
		DefaultValues.loadOutlineParam(this);
	}

	public OutlineParam(OutlineParam outline) {
		strokeWidth = outline.getStrokeWidth();
		strokeContrast = outline.getStrokeContrast();
		shadowLevel = outline.getShadowLevel();
		shadowContrast = outline.getShadowContrast();
		shadowPosition = outline.getShadowPosition();
		shadowDistance = outline.getShadowDistance();
		strokeVisible = outline.isStrokeVisible();
	}

	public float getStrokeWidth() {
		return strokeWidth;
	}

	public void setStrokeWidth(float strokeWidth) {
		this.strokeWidth = strokeWidth;
	}

	public float getStrokeContrast() {
		return strokeContrast;
	}

	public void setStrokeContrast(float strokeContrast) {
		this.strokeContrast = strokeContrast;
	}

	public float getShadowLevel() {
		return shadowLevel;
	}

	public void setShadowLevel(float shadowLevel) {
		this.shadowLevel = shadowLevel;
	}

	public float getShadowContrast() {
		return shadowContrast;
	}

	public void setShadowContrast(float shadowContrast) {
		this.shadowContrast = shadowContrast;
	}

	public void randomSet() {
		strokeWidth = (float) (Math.random() * 2);
		strokeContrast = (float) Math.random();
		shadowLevel = (float) Math.random();
		shadowContrast = (float) Math.random();
		shadowPosition = (float) Math.random() * PConstants.TWO_PI;
		shadowDistance = (float) Math.random() / 2;
	}

	public void randomWalk() {
		strokeWidth += (float) Math.random() * 2;
		strokeContrast += (float) (Math.random() / 5);
		shadowLevel += (float) (Math.random() / 5);
		shadowContrast = (float) PApplet.constrain(
				(float) (shadowContrast + Math.random() / 5), 0f, 1f);
		shadowDistance += (float) (Math.random() / 5);
	}

	public String[] getSaveStrings() {
		String[] result = new String[7];
		result[0] = (PApplet.str(strokeWidth));
		result[1] = (PApplet.str(strokeContrast));
		result[2] = (PApplet.str(shadowLevel));
		result[3] = (PApplet.str(shadowContrast));
		result[4] = (PApplet.str(shadowPosition));
		result[5] = (PApplet.str(shadowDistance));
		result[6] = (PApplet.str(strokeVisible));
		return result;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		strokeWidth = Float.parseFloat(toLoad.remove(0));
		strokeContrast = Float.parseFloat(toLoad.remove(0));
		shadowLevel = Float.parseFloat(toLoad.remove(0));
		shadowContrast = Float.parseFloat(toLoad.remove(0));
		shadowPosition = Float.parseFloat(toLoad.remove(0));
		shadowDistance = Float.parseFloat(toLoad.remove(0));
		strokeVisible = Boolean.parseBoolean(toLoad.remove(0));
		return toLoad;
	}

}
