import processing.core.PApplet;
import sojamo.drop.*;

public class Rendering extends PApplet {
	private static final long serialVersionUID = 1L;

	SwingMain swingWindow;

	SandBox sandBox;

	SDrop sDrop;

	public void setup() {
		// DefaultValues.size(this);
		size(500, 500);
		smooth();
		frameRate(2);
		sDrop = new SDrop(this);
		swingWindow = new SwingMain(this);
		sandBox = new SandBox(this);
		sandBox.testSetup();
	}

	public void draw() {
		sandBox.testDraw();
	}

	public void keyPressed() {
		sandBox.keyPressed();
	}

	public void mousePressed() {
		sandBox.mousePressed();
	}

	public void saveSpriteSheet(String name) {
		sandBox.saveSheet(name);
	}

	public void updateSheet() {
		sandBox.updateSheet();
	}

	public void extend() {
		sandBox.extend();
	}

	public void randomMonster() {
		sandBox.randomMonster();
	}

	public static void main(String[] args) {
		PApplet.main(new String[] { "Rendering" });
	}

	void dropEvent(DropEvent theDropEvent) {
		System.out.println(theDropEvent.file().toString());
		sandBox.mainBody.loadMonsterFile(theDropEvent.file().toString());
		swingWindow.setFileName(MyUtils.fileNameOf(theDropEvent.file()
				.toString()));
	}
}
