import java.util.Vector;

import processing.core.PApplet;

public class ScalingParam {

	public float getX() {
		return x;
	}

	public void setX(float x) {
		this.x = x;
	}

	public float getY() {
		return y;
	}

	public void setY(float y) {
		this.y = y;
	}

	public float getW() {
		return w;
	}

	public void setW(float w) {
		this.w = w;
	}

	public float getH() {
		return h;
	}

	public void setH(float h) {
		this.h = h;
	}

	public float getR() {
		return r;
	}

	public void setR(float r) {
		this.r = r;
	}

	public float getS() {
		return s;
	}

	public void setS(float s) {
		this.s = s;
	}

	public float getL() {
		return l;
	}

	public void setL(float l) {
		this.l = l;
	}

	float x;// x translation
	float y;// y translation
	float w;// x scaling
	float h;// y scaling
	float r;// rotation
	float s;// general scaling
	float l;// length, in some case

	public ScalingParam() {
		this.w = 1;
		this.h = 1;
		this.l = (float) 0.5;
		this.r = 0;
		this.s = 1;
		this.x = 0;
		this.y = 0;
	}

	public void setSize(float w, float h) {
		this.w = w;
		this.h = h;
	}

	public void setTran(float x, float y) {
		this.x = x;
		this.y = y;
	}

	public void randomSet() {
		x = (float) 0;
		y = (float) 0;
		float basicS = (float) Math.random() / 2;
		w = basicS;
		h = basicS;
		r = (float) 0;
		s = (float) 1;
		l = (float) Math.random();
	}

	public void randomScale() {
		float basicS = (float) Math.random() / 2;
		w = Math.max(w - basicS, 0.1f);
		h = Math.max(h - basicS, 0.1f);
		l = l + (float) (Math.random() / 5);
	}

	public void randomTrans() {
		x = x + (float) (Math.random() * 2 - 1) / 10;
		y = y + (float) (Math.random() * 2 - 1) / 10;
	}

	public String[] getSaveStrings() {
		String[] result = new String[7];
		result[0] = PApplet.str(x);
		result[1] = PApplet.str(y);
		result[2] = PApplet.str(w);
		result[3] = PApplet.str(h);
		result[4] = PApplet.str(s);
		result[5] = PApplet.str(r);
		result[6] = PApplet.str(l);
		return result;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		x = Float.parseFloat(toLoad.remove(0));
		y = Float.parseFloat(toLoad.remove(0));
		w = Float.parseFloat(toLoad.remove(0));
		h = Float.parseFloat(toLoad.remove(0));
		s = Float.parseFloat(toLoad.remove(0));
		r = Float.parseFloat(toLoad.remove(0));
		l = Float.parseFloat(toLoad.remove(0));
		return toLoad;
	}

}
