import java.util.Vector;

import processing.core.PApplet;

public class Shape {
	Vector<Float> x;
	Vector<Float> y;
	int size;

	Shape() {
		x = new Vector<Float>();
		y = new Vector<Float>();
		size = 0;
	}

	public void add(float xToAdd, float yToAdd) {
		x.add(xToAdd);
		y.add(yToAdd);
		size++;
	}

	public float getX(int i) {
		return x.get(i);
	}

	public float getY(int i) {
		return y.get(i);
	}

	public int size() {
		return size;
	}

	public boolean isIn(int current, Shape toMatch) {
		float x = this.x.get(current);
		float y = this.y.get(current);
		Shape p = toMatch;
		int i, j, c = 0;
		for (i = 0, j = p.size() - 1; i < p.size(); j = i++) {
			if ((((p.getY(i) <= y) && (y < p.getY(j))) || ((p.getY(j) <= y) && (y < p
					.getY(i))))
					&& (x < (p.getX(j) - p.getX(i)) * (y - p.getY(i))
							/ (p.getY(j) - p.getY(i)) + p.getX(i)))
				c = (c + 1) % 2;
		}
		return c == 1;
	}

	public Shape closest(int i, Shape toMatch) {
		Shape result = new Shape();
		result.add(toMatch.getX(0), toMatch.getY(0));
		for (int i2 = 1; i2 < toMatch.size(); i2++) {
			if (distance(i, toMatch.getX(i2), toMatch.getY(i2)) < distance(i,
					result.getX(0), result.getY(0))) {
				result.set(0, toMatch.getX(i2), toMatch.getY(i2));
			}
		}
		return result;
	}

	private void set(int i, float x2, float y2) {
		x.set(i, x2);
		y.set(i, y2);
	}

	private float distance(int i, float x2, float y2) {
		return PApplet.dist(x.get(i), y.get(i), x2, y2);
	}

	public void translate(float xT, float yT) {
		for (int i = 0; i < size; i++) {
			x.set(i, x.get(i) + xT);
			y.set(i, y.get(i) + yT);
		}
	}

	public void addShape(Shape subShape) {
		for (int i = 0; i < subShape.size(); i++) {
			add(subShape.getX(i), subShape.getY(i));
		}
	}

	public Shape get(int i) {
		Shape shape = new Shape();
		shape.add(x.get(i), y.get(i));
		return shape;
	}

	public Shape getLast() {
		return get(size - 1);
	}
}
