import javax.swing.BorderFactory;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;

public class SwingColor extends SwingWindow {
	private static final long serialVersionUID = 1L;

	JSlider alpha;
	JSlider hue;
	JSlider saturation;
	JSlider brightness;

	ColorParam color;

	private int divisions;

	SwingColor(Rendering p, ColorParam color) {
		super(p, color);
	}

	@Override
	protected void setTheContent(Object object) {
		this.color = (ColorParam) object;
		this.divisions = 0xFF;
		alpha = new JSlider(1, 0, divisions, (color.getA() + 0xFF) % 0xFF);
		alpha.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Alpha"));
		alpha.addChangeListener(this);
		b.add(alpha);
		hue = new JSlider(1, 0, divisions, (int) (color.getHue() * divisions));
		hue.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Hue"));
		hue.addChangeListener(this);
		b.add(hue);
		saturation = new JSlider(1, 0, divisions,
				(int) (color.getSaturation() * divisions));
		saturation.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Saturation"));
		saturation.addChangeListener(this);
		b.add(saturation);
		brightness = new JSlider(1, 0, divisions,
				(int) (color.getBrightness() * divisions));
		brightness.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Brightness"));
		brightness.addChangeListener(this);
		b.add(brightness);
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		if (!source.getValueIsAdjusting()) {
			color.setAHSB((byte) (alpha.getValue() * 0xFF / divisions),
					(float) hue.getValue() * 1 / divisions, (float) saturation
							.getValue()
							* 1 / divisions, (float) brightness.getValue() * 1
							/ divisions);
			parent.updateSheet();
		}
	}

}
