import java.awt.event.ActionEvent;
import javax.swing.JButton;
import javax.swing.JTextField;

public class SwingMain extends SwingWindow {
	private static final long serialVersionUID = 1L;

	JButton sprite;
	JButton scaling;
	JButton color;
	JButton outline;
	JButton unique;
	JButton patchable;
	JButton update;
	JButton extend;
	JButton save;
	JButton sets;
	JTextField name;

	SwingMain(Rendering p) {
		super(p);
	}

	protected void setTheContent(Object object) {
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		sprite = new JButton("sprite");
		sprite.addActionListener(this);
		b.add(sprite);
		scaling = new JButton("scaling");
		scaling.addActionListener(this);
		b.add(scaling);
		color = new JButton("color");
		color.addActionListener(this);
		b.add(color);
		outline = new JButton("outline");
		outline.addActionListener(this);
		b.add(outline);
		unique = new JButton("unique");
		unique.addActionListener(this);
		b.add(unique);
		patchable = new JButton("patchable");
		patchable.addActionListener(this);
		b.add(patchable);
		update = new JButton("update");
		update.addActionListener(this);
		b.add(update);
		extend = new JButton("extend");
		extend.addActionListener(this);
		b.add(extend);
		save = new JButton("save");
		save.addActionListener(this);
		b.add(save);
		sets = new JButton("sets");
		sets.addActionListener(this);
		b.add(sets);
		name = new JTextField("name");
		b.add(name);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == sprite) {
			new SwingSprite(parent);
		} else if (source == scaling) {
			new SwingScaling(parent, parent.sandBox.mainBody.scaling);
		} else if (source == color) {
			new SwingColor(parent, parent.sandBox.mainBody.color);
		} else if (source == outline) {
			new SwingOutline(parent, parent.sandBox.mainBody.outline);
		} else if (source == unique) {
			new SwingUnique(parent);
		} else if (source == patchable) {
			new SwingPatchable(parent);
		} else if (source == update) {
			parent.updateSheet();
		} else if (source == save) {
			parent.saveSpriteSheet(name.getText());
		} else if (source == extend) {
			parent.extend();
		} else if (source == sets) {
			new SwingSets(parent);
		}
	}

	public void setFileName(String newName) {
		name.setText(newName);
	}
	
}
