import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;

import processing.core.PConstants;

public class SwingOutline extends SwingWindow {
	private static final long serialVersionUID = 1L;

	OutlineParam outline;

	JButton strokeVisible;
	JSlider strokeWidth;
	JSlider strokeContrast;
	JSlider shadowLevel;
	JSlider shadowContrast;
	JSlider shadowPosition;
	JSlider shadowDistance;

	int divisions;

	SwingOutline(Rendering p, OutlineParam outline) {
		super(p, outline);
	}

	@Override
	protected void setTheContent(Object object) {
		this.outline = (OutlineParam) object;
		divisions = 0xFF;
		strokeVisible = new JButton("Stroke visible");
		strokeVisible.addActionListener(this);
		b.add(strokeVisible);
		strokeWidth = new JSlider(1, 0, divisions, (int) (outline
				.getStrokeWidth()
				* divisions / 5));
		strokeWidth.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Stroke width"));
		strokeWidth.addChangeListener(this);
		b.add(strokeWidth);
		strokeContrast = new JSlider(1, 0, divisions, (int) (outline
				.getStrokeContrast() * divisions));
		strokeContrast.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Stroke constrast"));
		strokeContrast.addChangeListener(this);
		b.add(strokeContrast);
		shadowLevel = new JSlider(1, 0, divisions, (int) (outline
				.getShadowLevel() * divisions));
		shadowLevel.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Shadow level"));
		shadowLevel.addChangeListener(this);
		b.add(shadowLevel);
		shadowContrast = new JSlider(1, 0, divisions, (int) (outline
				.getShadowContrast() * divisions));
		shadowContrast.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "Shadow contrast"));
		shadowContrast.addChangeListener(this);
		b.add(shadowContrast);
		shadowPosition = new JSlider(1, 0, divisions, (int) (outline
				.getShadowPosition()
				* divisions / PConstants.TWO_PI));
		shadowPosition.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "shadow position"));
		shadowPosition.addChangeListener(this);
		b.add(shadowPosition);
		shadowDistance = new JSlider(1, 0, divisions, (int) (outline
				.getShadowDistance() * divisions));
		shadowDistance.setBorder(BorderFactory.createTitledBorder(BorderFactory
				.createEmptyBorder(0, 0, 10, 100), "shadow distance"));
		shadowDistance.addChangeListener(this);
		b.add(shadowDistance);
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		if (!source.getValueIsAdjusting()) {
			if (source == strokeWidth) {
				outline.setStrokeWidth((float) source.getValue() * 5
						/ divisions);
			}
			if (source == strokeContrast) {
				outline.setStrokeContrast((float) source.getValue() * 1
						/ divisions);
			}
			if (source == shadowLevel) {
				outline.setShadowLevel((float) source.getValue() * 1
						/ divisions);
			}
			if (source == shadowContrast) {
				outline.setShadowContrast((float) source.getValue() * 1
						/ divisions);
			}
			if (source == shadowPosition) {
				outline.setShadowPosition((float) source.getValue()
						* PConstants.TWO_PI / divisions);
			}
			if (source == shadowDistance) {
				outline.setShadowDistance((float) source.getValue() * 1
						/ divisions);
			}
			parent.updateSheet();
		}
	}

	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == strokeVisible) {
			outline.switchStrokeVisible();
		}
	}

}