import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class SwingPatchable extends SwingWindow implements
		ListSelectionListener {
	private static final long serialVersionUID = 1L;

	JList element;
	JButton add0;
	JButton add1;
	JButton add2;
	JButton add3;
	JButton remove;
	JButton bound;
	JButton scaling;
	JButton color;
	JButton outline;
	JButton movement;
	JSlider shape;

	int divisions;

	private boolean SlidersListeners;

	SwingPatchable(Rendering p) {
		super(p);
	}

	@Override
	protected void setTheContent(Object object) {
		divisions = 0xFF;
		String[] data = parent.sandBox.mainBody.constitution.getPLList();
		element = new JList(data);
		element.setBorder(BorderFactory.createTitledBorder("Element"));
		element.addListSelectionListener(this);
		b.add(element);
		// test this by : element.getSelectedValue();
		add0 = new JButton("add beak");
		add0.addActionListener(this);
		b.add(add0);
		add1 = new JButton("add block");
		add1.addActionListener(this);
		b.add(add1);
		add2 = new JButton("add eye");
		add2.addActionListener(this);
		b.add(add2);
		add3 = new JButton("add tentacle");
		add3.addActionListener(this);
		b.add(add3);
		remove = new JButton("remove");
		remove.addActionListener(this);
		b.add(remove);
		bound = new JButton("bound");
		bound.addActionListener(this);
		b.add(bound);
		scaling = new JButton("scaling");
		scaling.addActionListener(this);
		b.add(scaling);
		color = new JButton("color");
		color.addActionListener(this);
		b.add(color);
		outline = new JButton("outline");
		outline.addActionListener(this);
		b.add(outline);
		movement = new JButton("movement");
		movement.addActionListener(this);
		b.add(movement);
		shape = new JSlider(0, 0, 4, 0);
		shape.setBorder(BorderFactory.createTitledBorder("shape"));
		shape.addChangeListener(this);
		b.add(shape);
	}

	public void valueChanged(ListSelectionEvent e) {
		JList source = (JList) e.getSource();
		loadValuesOf(source.getSelectedIndex());
	}

	private void loadValuesOf(int i) {
		SlidersListeners = false;
		if (i != -1) {
			shape.setValue(parent.sandBox.mainBody.constitution.pLimb.get(i)
					.getShapeType());
		}
		SlidersListeners = true;
	}

	public void stateChanged(ChangeEvent e) {
		if (SlidersListeners) {
			JSlider source = (JSlider) e.getSource();
			if (!source.getValueIsAdjusting()) {
				if (source == shape) {
					parent.sandBox.mainBody.constitution.pLimb.get(
							element.getSelectedIndex()).setShapeType(
							source.getValue());
				}
				parent.updateSheet();
			}
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == add0) {
			parent.sandBox.mainBody.addPatchable(0);
			updateList();
		}
		if (source == add1) {
			parent.sandBox.mainBody.addPatchable(1);
			updateList();
		}
		if (source == add2) {
			parent.sandBox.mainBody.addPatchable(2);
			updateList();
		}
		if (source == add3) {
			parent.sandBox.mainBody.addPatchable(3);
			updateList();
		}
		if (source == remove) {
			parent.sandBox.mainBody.removePLimb(element.getSelectedIndex());
			updateList();
		}
		if (source == scaling) {
			new SwingScaling(parent, parent.sandBox.mainBody.constitution.pLimb
					.get(element.getSelectedIndex()).getScaling());
		}
		if (source == color) {
			new SwingColor(parent, parent.sandBox.mainBody.constitution.pLimb
					.get(element.getSelectedIndex()).getColor());
		}
		if (source == outline) {
			new SwingOutline(parent, parent.sandBox.mainBody.constitution.pLimb
					.get(element.getSelectedIndex()).getOutline());
		}
		if (source == bound) {
			new SwingBound(parent, parent.sandBox.mainBody.constitution.pLimb
					.get(element.getSelectedIndex()).getBound());
		}
		if (source == movement) {
			new SwingMovement(parent,
					parent.sandBox.mainBody.constitution.pLimb.get(
							element.getSelectedIndex()).getMovement());
		}
		parent.updateSheet();
	}

	private void updateList() {
		String[] data = parent.sandBox.mainBody.constitution.getPLList();
		element.setListData(data);
	}

}
