import javax.swing.BorderFactory;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;

import processing.core.PConstants;

public class SwingScaling extends SwingWindow {
	private static final long serialVersionUID = 1L;

	ScalingParam scaling;

	JSlider x;
	JSlider y;
	JSlider w;
	JSlider h;
	JSlider r;
	JSlider s;
	JSlider l;

	int divisions;

	SwingScaling(Rendering p, ScalingParam scaling) {
		super(p, scaling);
	}

	@Override
	protected void setTheContent(Object object) {
		this.scaling = (ScalingParam) object;
		this.divisions = 100;
		x = new JSlider(1, -divisions, divisions,
				(int) (scaling.getX() * divisions));
		x.setBorder(BorderFactory.createTitledBorder(null, "x", 2, 1));
		x.addChangeListener(this);
		b.add(x);
		y = new JSlider(1, -divisions, divisions,
				(int) (scaling.getY() * divisions));
		y.setBorder(BorderFactory.createTitledBorder(null, "y", 2, 1));
		y.addChangeListener(this);
		b.add(y);
		w = new JSlider(1, 0, divisions, (int) (scaling.getW() * divisions));
		w.setBorder(BorderFactory.createTitledBorder(null, "w", 2, 1));
		w.addChangeListener(this);
		b.add(w);
		h = new JSlider(1, 0, divisions, (int) (scaling.getH() * divisions));
		h.setBorder(BorderFactory.createTitledBorder(null, "h", 2, 1));
		h.addChangeListener(this);
		b.add(h);
		r = new JSlider(1, -divisions, divisions, (int) (scaling.getR()
				* (float) divisions / PConstants.TWO_PI));
		r.setBorder(BorderFactory.createTitledBorder(null, "r", 2, 1));
		r.addChangeListener(this);
		b.add(r);
		s = new JSlider(1, 0, divisions, (int) (scaling.getS() * divisions));
		s.setBorder(BorderFactory.createTitledBorder(null, "s", 2, 1));
		s.addChangeListener(this);
		b.add(s);
		l = new JSlider(1, 0, divisions, (int) (scaling.getL() * divisions));
		l.setBorder(BorderFactory.createTitledBorder(null, "l", 2, 1));
		l.addChangeListener(this);
		b.add(l);
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		if (!source.getValueIsAdjusting()) {
			if (source == x) {
				scaling.setX((float) source.getValue() / divisions);
			} else if (source == y) {
				scaling.setY((float) source.getValue() / divisions);
			} else if (source == w) {
				scaling.setW((float) source.getValue() / divisions);
			} else if (source == h) {
				scaling.setH((float) source.getValue() / divisions);
			} else if (source == r) {
				scaling.setR((float) ((float) source.getValue()
						* PConstants.TWO_PI / divisions));
			} else if (source == s) {
				scaling.setS((float) source.getValue() / divisions);
			} else if (source == l) {
				scaling.setL((float) source.getValue() / divisions);
			}
			parent.updateSheet();
		}
	}

}
