import java.awt.event.ActionEvent;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JSlider;
import javax.swing.event.ChangeEvent;

public class SwingSprite extends SwingWindow {
	private static final long serialVersionUID = 1L;

	JSlider width;
	JSlider height;
	JSlider sSize;
	JButton configAll;
	JButton configWalker;
	JButton configFlyer;
	JButton configJumper;
	JButton findSize;

	SwingSprite(Rendering p) {
		super(p);
	}

	protected void setTheContent(Object object) {
		width = new JSlider(0, 1, 1000, 70);
		width.setBorder(BorderFactory.createTitledBorder("width"));
		width.addChangeListener(this);
		b.add(width);
		height = new JSlider(0, 1, 1000, 70);
		height.setBorder(BorderFactory.createTitledBorder("height"));
		height.addChangeListener(this);
		b.add(height);
		sSize = new JSlider(0, 1, 1000, 70);
		sSize.setBorder(BorderFactory.createTitledBorder("sSize"));
		sSize.addChangeListener(this);
		b.add(sSize);
		configAll = new JButton("Entire");
		configAll.addActionListener(this);
		b.add(configAll);
		configWalker = new JButton("Walker");
		configWalker.addActionListener(this);
		b.add(configWalker);
		configFlyer = new JButton("Flyer");
		configFlyer.addActionListener(this);
		b.add(configFlyer);
		configJumper = new JButton("Jumper");
		configJumper.addActionListener(this);
		b.add(configJumper);
		findSize = new JButton("AutoSize");
		findSize.addActionListener(this);
		b.add(findSize);
	}

	public void stateChanged(ChangeEvent e) {
		JSlider source = (JSlider) e.getSource();
		if (source == width) {
			parent.sandBox.mainBody.getSpriteSheet().setSpriteWidth(
					source.getValue());
		}
		if (source == height) {
			parent.sandBox.mainBody.getSpriteSheet().setSpriteHeight(
					source.getValue());
		}
		if (source == sSize) {
			parent.sandBox.mainBody.setWidth(source.getValue());
			parent.sandBox.mainBody.setHeight(source.getValue());
			parent.sandBox.mainBody.getSpriteSheet().setSpriteHeight(
					source.getValue());
			parent.sandBox.mainBody.getSpriteSheet().setSpriteWidth(
					source.getValue());
		}
		if (!source.getValueIsAdjusting()) {
			parent.updateSheet();
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		JButton source = (JButton) e.getSource();
		if (source == configAll) {
			int[] nbFrames = { 1, 8, 8, 8, 8, 8, 8, 8 };
			parent.sandBox.mainBody.getSpriteSheet().getAnimation()
					.setNbFrames(nbFrames);
		}
		if (source == configWalker) {
			int[] nbFrames = { 0, 24, 36, 17, 0, 0, 0, 0 };
			parent.sandBox.mainBody.getSpriteSheet().getAnimation()
					.setNbFrames(nbFrames);
		}
		if (source == configFlyer) {
			int[] nbFrames = { 0, 0, 0, 0, 13, 0, 0, 0 };
			parent.sandBox.mainBody.getSpriteSheet().getAnimation()
					.setNbFrames(nbFrames);
		}
		if (source == configJumper) {
			int[] nbFrames = { 0, 0, 0, 0, 0, 13, 12, 11 };
			parent.sandBox.mainBody.getSpriteSheet().getAnimation()
					.setNbFrames(nbFrames);
		}
		if (source == findSize) {
			parent.sandBox.mainBody.getSpriteSheet().findBestSize();
		}
		parent.updateSheet();
	}
}
