import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public abstract class SwingWindow extends JFrame implements ActionListener,
		WindowListener, ChangeListener {
	private static final long serialVersionUID = 1L;

	Box b;
	Rendering parent;

	SwingWindow() {
		setDefaultLookAndFeelDecorated(true);
		setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		b = new Box(BoxLayout.X_AXIS);
		setTheContent(null);
		add(b);
		pack();
		setVisible(true);
	}

	SwingWindow(Rendering p) {
		this.parent = p;
		setDefaultLookAndFeelDecorated(true);
		setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		b = new Box(BoxLayout.X_AXIS);
		setTheContent(null);
		add(b);
		pack();
		setVisible(true);
	}

	public SwingWindow(Rendering p, Object object) {
		this.parent = p;
		setDefaultLookAndFeelDecorated(true);
		setLayout(new BoxLayout(getContentPane(), BoxLayout.Y_AXIS));
		b = new Box(BoxLayout.X_AXIS);
		setTheContent(object);
		add(b);
		pack();
		setVisible(true);
	}

	abstract protected void setTheContent(Object object);

	public void actionPerformed(ActionEvent e) {
	}

	public void windowActivated(WindowEvent e) {
	}

	public void windowClosed(WindowEvent e) {
	}

	public void windowClosing(WindowEvent e) {
	}

	public void windowDeactivated(WindowEvent e) {
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}

	public void stateChanged(ChangeEvent e) {
	}

}
