import processing.core.PApplet;
import processing.core.PConstants;

public class TentaclePLimb extends PatchableLimb {

	TentaclePLimb(PApplet p, Constitution constitution) {
		super(p, constitution);
		type = 3;
	}

	protected void drawStillRender() {
		float lParam = scaling.getL() * 2;
		int divs = 32;
		render.beginShape();
		render.vertex(0, 0);
		for (int i = 0; i < divs; i++) {
			float going = (float) i / divs;
			float x = -1 * (1 - going) / 2;
			x += PApplet.sin(((going) % 1) * PConstants.TWO_PI) * (lParam / 3);
			float y = lParam * going;
			render.vertex(x, y);
		}
		for (int i = 0; i < divs; i++) {
			float going = (float) i / divs;
			float x = 1 * going / 2;
			x -= PApplet.sin((1 - (((1 - going)) % 1)) * PConstants.TWO_PI)
					* (lParam / 3);
			float y = lParam * (1 - going);
			render.vertex(x, y);
		}
		render.vertex(0, 0);
		render.endShape();
	}

	protected void drawMovingRender(float time) {
		float lParam = scaling.getL() * 2;
		int divs = 32;
		render.beginShape();
		render.vertex(0, 0);
		for (int i = 0; i < divs; i++) {
			float going = (float) i / divs;
			float x = -1 * (1 - going) / 2;
			x += PApplet.sin(((going + time) % 1) * PConstants.TWO_PI)
					* (lParam / 3);
			float y = lParam * going;
			render.vertex(x, y);
		}
		for (int i = 0; i < divs; i++) {
			float going = (float) i / divs;
			float x = 1 * going / 2;
			x -= PApplet.sin((1 - (((1 - going) + time) % 1))
					* PConstants.TWO_PI)
					* (lParam / 3);
			float y = lParam * (1 - going);
			render.vertex(x, y);
		}
		render.vertex(0, 0);
		render.endShape();
	}

	@Override
	protected void drawFFlyingRender(float time) {
		drawMovingRender(time);
	}

	@Override
	protected void drawJAirRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawJCrounchRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawJgroundRender(float time) {
		drawMovingRender(time);
	}

	@Override
	protected void drawWIdlingRender(float time) {
		drawMovingRender(time);
	}

	@Override
	protected void drawWJumpingRender(float time) {
		drawStillRender();
	}

	@Override
	protected void drawWWalkingRender(float time) {
		drawMovingRender(time);
	}

}
