import java.util.Vector;

import processing.core.PApplet;
import processing.core.PGraphics;

abstract public class UniqueLimb extends Limbs {

	public int getNumber() {
		return number;
	}

	public void setNumber(int number) {
		this.number = number;
	}

	public float getVariance() {
		return variance;
	}

	public void setVariance(float variance) {
		this.variance = variance;
	}

	int number;// number of limbs of one type
	float variance;// (0 - 1) variance between each instance of one type

	UniqueLimb(PApplet p) {
		super(p);
		DefaultValues.loadULimb(this);
	}

	public PGraphics displayStill(float w, float h) {
		return displayAnim(w, h, -1, 0);
	}

	abstract PGraphics displayAnim(float w, float h, float time, int anim);

	protected void setColorVariance(int i) {
		render.stroke(color.getContrasted(outline.getStrokeContrast()));
		render.fill(color.getARGBInt());
		if (!outline.isStrokeVisible()) {
			render.noStroke();
		}
	}

	protected void setShadowColor(int i) {
		render.noStroke();
		render.fill(color.getShadowed(outline));
	}

	public void randomSet() {
		super.randomSet();
		number = (int) (Math.random() * 4);
		variance = (float) Math.random();
	}

	protected void drawClassic(int anim, int iter, float time) {

	}

	protected void drawStillRender(int iter) {
		drawClassic(0, iter, -1);
	}

	protected void drawWWalkingRender(int iter, float time) {
		drawClassic(1, iter, time);
	}

	protected void drawWIdlingRender(int iter, float time) {
		drawClassic(2, iter, time);
	}

	protected void drawWJumpingRender(int iter, float time) {
		drawClassic(3, iter, time);
	}

	protected void drawFFlyingRender(int iter, float time) {
		drawClassic(4, iter, time);
	}

	protected void drawJCrounchRender(int iter, float time) {
		drawClassic(5, iter, time);
	}

	protected void drawJAirRender(int iter, float time) {
		drawClassic(6, iter, time);
	}

	protected void drawJgroundRender(int iter, float time) {
		drawClassic(7, iter, time);
	}

	public String[] getSaveStrings() {
		Vector<String> result = new Vector<String>();
		result = MyUtils.addStringArray(result, super.getSaveStrings());
		result.add(PApplet.str(number));
		result.add(PApplet.str(variance));
		result = MyUtils.addStringArray(result, getAdditionnalSaveStrings());
		String[] result2 = MyUtils.toStrArray(result);
		return result2;
	}

	public Vector<String> loadSaveStrings(Vector<String> toLoad) {
		toLoad = super.loadSaveStrings(toLoad);
		number = Integer.parseInt(toLoad.remove(0));
		variance = Float.parseFloat(toLoad.remove(0));
		toLoad = loadAdditionnalSaveStrings(toLoad);
		return toLoad;
	}

	abstract protected Vector<String> loadAdditionnalSaveStrings(
			Vector<String> toLoad);

	abstract protected String[] getAdditionnalSaveStrings();
}
