import java.util.Vector;

import processing.core.PApplet;
import processing.core.PConstants;
import processing.core.PGraphics;

public class WingsULimb extends UniqueLimb {

	float largeur;
	float base;

	protected String[] getAdditionnalSaveStrings() {
		Vector<String> result = new Vector<String>();
		result.add(PApplet.str(largeur));
		result.add(PApplet.str(base));
		String[] result2 = MyUtils.toStrArray(result);
		return result2;
	}

	public Vector<String> loadAdditionnalSaveStrings(Vector<String> toLoad) {
		largeur = Float.parseFloat(toLoad.remove(0));
		base = Float.parseFloat(toLoad.remove(0));
		return toLoad;
	}

	public WingsULimb(PApplet p) {
		super(p);
		DefaultValues.loadWings(this);
	}

	public PGraphics displayAnim(float w, float h, float time, int anim) {
		beginRender(w, h);
		for (int i = 0; i < number; i++) {
			setColorVariance(i);
			render.noStroke();
			drawShape(anim, i, time);
		}
		for (int i = 0; i < number; i++) {
			setColorVariance(i);
			render.noFill();
			drawShapeWithoutShadow(anim, i, time);
		}
		endRender();
		return render;
	}

	protected void drawShape(int animType, int iter, float time) {
		drawShapeWithoutShadow(animType, iter, time);
		drawShadow(animType, iter, time);
	}

	protected void drawShapeWithoutShadow(int animType, int iter, float time) {
		Shape[] anims = switchAnim(animType, iter, time, 1);
		mainShape = anims;
		render.beginShape();
		drawVertexes(anims[0]);
		render.endShape();
		render.beginShape();
		drawVertexes(anims[1]);
		render.endShape();
	}

	protected void drawShadow(int animType, int iter, float time) {
		setShadowColor(iter);
		// shifting of the shadow
		float xSh = (float) Math.cos(outline.getShadowPosition())
				* outline.getShadowDistance() / 3;
		float ySh = (float) Math.sin(outline.getShadowPosition())
				* outline.getShadowDistance() / 3;
		Shape[] anims = switchAnim(animType, iter, time, outline
				.getShadowLevel());
		render.pushMatrix();
		render.beginShape();
		render.translate(xSh, ySh);
		drawVertexesShadow(anims[0], mainShape[0], xSh, ySh);
		render.endShape();
		render.popMatrix();
		render.pushMatrix();
		render.beginShape();
		render.translate(xSh, ySh);
		drawVertexesShadow(anims[1], mainShape[1], xSh, ySh);
		render.endShape();
		render.popMatrix();
	}

	Shape[] switchAnim(int animType, int iter, float time, float size) {
		Shape[] shape = new Shape[2];
		for (int i = 0; i < 2; i++) {
			shape[i] = new Shape();
		}
		if (animType == 0) {
			return drawShapeStill(size, iter);
		} else if (animType == 1) {
			return drawShapeStill(size, iter);
		} else if (animType == 2) {
			return drawShapeStill(size, iter);
		} else if (animType == 3) {
			return drawShapeFlying(size, time, iter);
		} else if (animType == 4) {
			return drawShapeFlying(size, time, iter);
		} else if (animType == 5) {
			return drawShapeFlying(size, time, iter);
		} else if (animType == 6) {
			return drawShapeFlying(size, time, iter);
		} else if (animType == 7) {
			return drawShapeStill(size, iter);
		}
		return null;
	}

	private void drawAWing(Shape shape, float angle, float length) {
		float x, y;
		float PI = PConstants.PI;
		x = PApplet.cos(angle) * base;
		y = PApplet.sin(angle) * base;
		shape.add(x, y);
		x = PApplet.cos(angle - PI / (number * 3 / largeur)) * (base + length);
		y = PApplet.sin(angle - PI / (number * 3 / largeur)) * (base + length);
		shape.add(x, y);
		x = PApplet.cos(angle + PI / (number * 3 / largeur)) * (base + length);
		y = PApplet.sin(angle + PI / (number * 3 / largeur)) * (base + length);
		shape.add(x, y);
	}

	private Shape[] drawShapeStill(float size, int iter) {
		Shape[] shape = new Shape[2];
		for (int i = 0; i < 2; i++) {
			shape[i] = new Shape();
		}
		float PI = PConstants.PI;
		float length = scaling.getL();
		float angle = PI + (PI / (number * 2) * iter);
		drawAWing(shape[0], angle, length);
		drawAWing(shape[1], angle + (PI * 3 / 2 - angle) * 2, length);
		return shape;
	}

	private Shape[] drawShapeFlying(float size, float time, int iter) {
		Shape[] shape = new Shape[2];
		for (int i = 0; i < 2; i++) {
			shape[i] = new Shape();
		}
		float PI = PConstants.PI;
		float length = scaling.getL();
		float angle = PI + (PI / (number * 2) * iter);
		// the flapping stuff
		angle += (PApplet.sin(PI * 2 * ((time + iter / number) % 1)) + 1) / 2;
		drawAWing(shape[0], angle, length);
		drawAWing(shape[1], angle + (PI * 3 / 2 - angle) * 2, length);
		return shape;
	}

	public float getLargeur() {
		return largeur;
	}

	public void setLargeur(float largeur) {
		this.largeur = largeur;
	}

	public float getBase() {
		return base;
	}

	public void setBase(float base) {
		this.base = base;
	}

	public void randomSet() {
		super.randomSet();
		base = (float) (Math.random() * 0.2);
		largeur = (float) (Math.random() * 1);
		shapeType = (int) Math.floor(Math.random() * 1);
	}

}
